/* $Id: fullfactor_misc.gp,v 1.5 2007-12-18 11:50:18 jdemeyer Exp $ */

/* Like nextprime() and precprime() but for prime powers. */
nextprimepower(x) = {while(!isprimepower(x), x++); x;}
precprimepower(x) = {while(!isprimepower(x), x--); x;}


/* Given a t_INTMOD or t_POLMOD x,
 * return gcd of x with its modulus */
gcdmod(x) =
{
	gcd(lift(x), x.mod);
}


/* Convert x to a vector and flatten it */
Vecflat(x) =
{
	x = Vec(x);

	/* Return vector r */
	my(r = vector(0));
	for (i = 1, #x,
		my(t = x[i]);
		if (type(t) == "t_VEC", t = Vecflat(t), t = [t]);
		r = concat(r, t);
	);

	r;
}
